/**
 *  @file
 *
 *  This is an MPI-Program with an error!
 *
 *  It just calls
 *          - MPI_Init
 *          - MPI_Comm_rank
 *          - MPI_Comm_size
 *          - MPI_Type_contiguous
 *          - MPI_Send
 *          - MPI_Recv
 *          - MPI_Type_free
 *
 *  @author Tobias Hilbrich
 *
 *  $ID$
 */


#include <mpi.h>
#include <stdio.h>

int main(int argc, char **argv)
{
    int rank;
    int size;
    int sendBuf[4];
    int recvBuf[4];
    int MSG_TAG_1 = 1,
    MSG_TAG_2 = 2;

    MPI_Status status;

    MPI_Datatype cont2Int;
    MPI_Datatype cont4Int;

    MPI_Init(&argc, &argv);

    MPI_Comm_rank(MPI_COMM_WORLD, &rank);

    MPI_Comm_size(MPI_COMM_WORLD, &size);

    printf(" I am rank %d of %d PEs\n", rank, size);

    if (size < 2)
    {
        fprintf(stderr, " This program needs at least 2 PEs!\n");
    }
    else
    {
        sendBuf[0] = 1; sendBuf[1] = 2; sendBuf[2] = 3; sendBuf[3] = 4;

        //create two nice Datatype
        MPI_Type_contiguous(2, MPI_INT, &cont2Int);
        MPI_Type_contiguous(2, cont2Int, &cont4Int);

        if (rank == 0)
        {
            MPI_Send(sendBuf, 1, cont4Int, 1, MSG_TAG_1 ,MPI_COMM_WORLD);

            MPI_Recv(recvBuf, 1, cont4Int, 1, MSG_TAG_2 ,MPI_COMM_WORLD,&status);
        }
        if (rank == 1)
        {
            MPI_Recv(recvBuf, 1, cont4Int, 0, MSG_TAG_1 ,MPI_COMM_WORLD,&status);

            MPI_Send(sendBuf, 1, cont4Int, 0, MSG_TAG_2 ,MPI_COMM_WORLD);
        }

        MPI_Type_free (&cont4Int);

        MPI_Type_free (&cont2Int);
    }

    printf("rank: %d/size: %d buf: %d %d %d %d \n",rank,size,recvBuf[0],recvBuf[1],recvBuf[2],recvBuf[3]);

    MPI_Finalize();
    return 0;
}

/*EOF*/
